#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))
module GI.Pango.Objects.Layout where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

newtype Layout = Layout (ManagedPtr Layout)
instance GObject Layout where
class (GObject o, O.IsDescendantOf Layout o) => IsLayout o
instance (GObject o, O.IsDescendantOf Layout o) => IsLayout o
instance O.HasParentTypes Layout
#if ENABLE_OVERLOADING
data LayoutContextChangedMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutCopyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetAlignmentMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetAttributesMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetAutoDirMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetBaselineMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetCharacterCountMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetContextMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetCursorPosMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetEllipsizeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetExtentsMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetFontDescriptionMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetHeightMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetIndentMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetIterMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetJustifyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLineMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLineCountMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLineReadonlyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLinesMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLinesReadonlyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLogAttrsMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetLogAttrsReadonlyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetPixelExtentsMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetPixelSizeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetSerialMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetSingleParagraphModeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetSizeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetSpacingMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetTabsMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetTextMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetUnknownGlyphsCountMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetWidthMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutGetWrapMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutIndexToLineXMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutIndexToPosMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutIsEllipsizedMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutIsWrappedMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutMoveCursorVisuallyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetAlignmentMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetAttributesMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetAutoDirMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetEllipsizeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetFontDescriptionMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetHeightMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetIndentMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetJustifyMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetMarkupMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetMarkupWithAccelMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetSingleParagraphModeMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetSpacingMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetTabsMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetTextMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetWidthMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutSetWrapMethodInfo
#endif
#if ENABLE_OVERLOADING
data LayoutXyToIndexMethodInfo
#endif
