

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Pango.Objects
    (     module GI.Pango.Objects.Context         ,
    module GI.Pango.Objects.Engine          ,
    module GI.Pango.Objects.EngineLang      ,
    module GI.Pango.Objects.EngineShape     ,
    module GI.Pango.Objects.Font            ,
    module GI.Pango.Objects.FontFace        ,
    module GI.Pango.Objects.FontFamily      ,
    module GI.Pango.Objects.FontMap         ,
    module GI.Pango.Objects.Fontset         ,
    module GI.Pango.Objects.FontsetSimple   ,
    module GI.Pango.Objects.Layout          ,
    module GI.Pango.Objects.Renderer        ,


    ) where

import GI.Pango.Objects.Context
import GI.Pango.Objects.Engine
import GI.Pango.Objects.EngineLang
import GI.Pango.Objects.EngineShape
import GI.Pango.Objects.Font
import GI.Pango.Objects.FontFace
import GI.Pango.Objects.FontFamily
import GI.Pango.Objects.FontMap
import GI.Pango.Objects.Fontset
import GI.Pango.Objects.FontsetSimple
import GI.Pango.Objects.Layout
import GI.Pango.Objects.Renderer

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL



